<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2014  <Ivan Litovchenko>
 *  All rights reserved
 ***************************************************************/

	// Подключаем файл с глобальными конфигурациями...
if(file_exists(PATH_typo3conf.'conf.php')){
	require_once(PATH_typo3conf.'conf.php');
}

require_once ( t3lib_extMgm::extPath('phptemplate') . "plugins/class.validator.php" );
require_once ( t3lib_extMgm::extPath('phptemplate') . "plugins/func.php" );
require_once ( PATH_tslib . 'class.tslib_pibase.php' );
class tx_phptemplate_controller extends tslib_pibase {

	public $prefixId      = 'tx_phptemplate_controller'; // Same as class name
	public $scriptRelPath = 'pi1/class.tx_phptemplate_controller.php'; // Path to this script relative to the extension dir.
	public $extKey        = 'phptemplate'; // The extension key.

	public $conf = array();
	public $default_settings = array();
	public $assign_varible = array();
	public $plugins_list = array(
		/*
			Подумать еще также как можно сделать так
			что бы одни функции можно было использовать только в контроллере!
		*/
		'getEnv', 						// +
		'getVar', 						// + (пока нет необходимости, используем массив $_AR[])
		'getSource', 					// +
		'getMarker',					// +
		
		'imgRes', 						// +
		'url', 							// +
		'urlChangeLangParameter',		// + (вспомогательная функция - актуально для создания языковых переключателей [мультиязычные проекты])
		'safeUrl',						// +
		
		//'pageRenderAdd',						// + (пока не работает в _INT)
		//'pageRender_addCssFile',				// + (пока не работает в _INT) - возможно исключим, оставив только pageRender
		//'pageRender_addJsFile',				// + (пока не работает в _INT) - возможно исключим, оставив только pageRender
		//'pageRender_addFooterJsFile',			// + (пока не работает в _INT) - возможно исключим, оставив только pageRender
		//'pageRender_additionalHeaderData',	// +
		//'pageRender_additionalFooterData',	// +
		
		'tsObj', 						// +
		'tsCondition', 					// +
		'tsFormat', 					// +
		'includePartial',				// + // старые названия "includeBlock", "includeComponent"
		'pageContent',					// +
		'pageContentWithGridelements', 	// +
		
		'adminPanel', 					// +
		'eventIcon',					// +
		'editIcon', 					// +
		'editIconAbs', 					// +
		'editIconInline',				// +
		//'editIconCenter',				// - (поддержка исключена, добавлено как настройка!)
		'editWrapEnd',					// +
		'editWrapStart',				// +
		'newIcon', 						// +
		'goToModuleIcon',				// +
		'recordStatus',					// +
		'adminPanelNotepad',			// + решил включить в поддержку - в отдельных случаях может быть полезно
		
		'cycle',						// +
		'readDir',						// +
		'getFileInfo', 					// +
		'getFileInfo_OLD',				// +
		'getFileInfoWithReference',		// + (for TYPO3 6.0+)
		'str', 							// +
		
		'formSafeValue',				// + (функция стала АКТУАЛЬНА! доп. см.: #1293)
		'formSafeValueChecked',			// + (функция стала АКТУАЛЬНА! доп. см.: #1293)
		'formSafeValueSelected',		// + (функция стала АКТУАЛЬНА! доп. см.: #1293) - beta
		
		'print_r',						// + debug
		'writeToLog',					// +
		'sendMail',						// +
		
			// experemental:
			/*
				'XMLPROLOG_DOCTYPE'   => $this->xmlPrologAndDocType,
				'HTMLTAG'             => $this->htmlTag,
				'HEADTAG'             => $this->headTag,
				//'METACHARSET'       => $this->charSet ? str_replace('|', htmlspecialchars($this->charSet), $this->metaCharsetTag) : '',
				//'INLINECOMMENT'     => $this->inlineComments ? LF . LF . '<!-- ' . LF . implode(LF, $this->inlineComments) . '-->' . LF . LF : '',
				//'BASEURL'           => $this->baseUrl ? str_replace('|', $this->baseUrl, $this->baseUrlTag) : '',
				//'SHORTCUT'          => $this->favIcon ? sprintf($this->shortcutTag, htmlspecialchars($this->favIcon), $this->iconMimeType) : '',
				//'CSS_INCLUDE'       => $cssFiles,
				//'CSS_INLINE'        => $cssInline,
				//'JS_INLINE'         => $jsInline,
				//'JS_INCLUDE'        => $jsFiles,
				'JS_LIBS'      	      => $jsLibs,
				//'TITLE'             => $this->title ? str_replace('|', htmlspecialchars($this->title), $this->titleTag) : '',
				//'META'              => $metaTags,
				'HEADERDATA'          => $this->headerData ? implode(LF, $this->headerData) : '',
				'FOOTERDATA'          => $this->footerData ? implode(LF, $this->footerData) : '',
				'JS_LIBS_FOOTER'      => $jsFooterLibs,
				//'JS_INCLUDE_FOOTER' => $jsFooterFiles,
				//'JS_INLINE_FOOTER'  => $jsFooterInline,
				//'BODY'              => $this->bodyContent,
			*/
		
		
			// Ниже все плагины tpl_* поддержка не актуальная
		'tpl_render_TYPO3_Licenses',		// +
		'tpl_render_BaseName',				// +
		'tpl_render_Favicon',				// +
		'tpl_render_Title',					// +
		'tpl_render_Meta',					// +
		'tpl_render_CSS',					// +
		'tpl_render_JS',					// +
		'tpl_render_JSFooter',				// +
		'tpl_render_additionalHeaderData', 	// +
		'tpl_render_additionalFooterData', 	// +
		
			// Классы (думаем как лучше сделать)
		'classes' => array(
			'asset', 		// +
			'form', 		// +
			'location',		// +
			'validator', 	// +
		),
		
			// beta
		// 'fileInclude' // beta
		// 'fileExists' // beta
		
			// Плагины для EXT:spiderindexing
		'ext_Tx_SpiderIndexing_getEasySearchResult',					// +
		'ext_Tx_SpiderIndexing_getEasySearchDateLastUpdateIndex',		// +
		'ext_Tx_SpiderIndexing_getEasySearchCountResultInIndex',		// +
	);
	public $plugins_list_user = array();
	public $path_pre_controller = "";
	public $path_template_php_file = "";
	
	/**
	 * The main method of the Plugin.
	 *
	 * @param string $content The Plugin content
	 * @param array $conf The Plugin configuration
	 * @return string The content that is displayed on the website
	 */
	public function main($content, array $conf) {
		$this->prefixId      = get_class($this) ; // Same as class name
		$this->scriptRelPath = __FILE__; // Path to this script relative to the extension dir.
		
		$this->conf = t3lib_div::removeDotsFromTS($conf);
		$this->access(); // Beta - проверяем наличие доступа на выполнение скрипта
		$this->set_default(); // устанавливаем установки по умолчанию
		
		$this->create_localization_folder(); // создаем папку для локализации в БД
		$this->render($content, $this->conf);
		return $this->out();
	}
	
		// Beta - функция проверяет наличие доступа на выполнение скрипта
	public function access(){
		
			// В дальнейшем придумаем, как это можно реализовать было бы...
	}
	
		// Функция определения дефолтовых установок
	protected function set_default() {
		// register pluging; 
		$this->register_default_plugins_class(); // регистрируем дефолтовые плагины-классы
		$this->register_default_plugins(); // регистрируем дефолтовые переменные
		$this->register_user_plugins(); // регистрируем пользовательские папки с плагинами
		$this->assign_default_varible(); // регистрируем дефолтовые переменные
		// $GLOBALS['_POST'] = t3lib_div::_POST(); // #1293. вырезает слэши "stripslashes()"...
		// $GLOBALS['_GET'] = t3lib_div::_GET(); //
	}
		
		// Подключаем дефолтовые плагины-классы
	protected function register_default_plugins_class() {
		foreach ($this->plugins_list['classes'] as $cKey => $cName){
			if(file_exists(t3lib_extMgm::extPath('phptemplate').'plugins/class.'.$cName.'.php')) {
				require_once(t3lib_extMgm::extPath('phptemplate').'plugins/class.'.$cName.'.php');
				if (class_exists('phptemplate_plugin_class_' . $cName)) {
					if (empty($this->$cName)){
						$className = 'phptemplate_plugin_class_' . $cName;
						$this->$cName = new $className;
					}
				}
			}
		}
	}
	
		// Подключаем дефолтовые плагины
	protected function register_default_plugins() {
		$this->conf['plugins_dir'] = PATH_typo3conf . "AllUserPlugins/";
	}
	
		// Подключаем дефолтовые плагины
	protected function register_user_plugins() {
	}
	
		function __call($name, array $args) { 
			$prefix = explode("_", $name);
			if ($prefix[0] == "user") {
				if (!file_exists(t3lib_div::getFileAbsFileName($this->conf['plugins_dir'])) && !is_dir(t3lib_div::getFileAbsFileName($this->conf['plugins_dir']))) {
					# throw new \TYPO3\CMS\Core\Error\Http\ServiceUnavailableException('Directory "'.$this->conf['plugins_dir'].'" does not exist', 1);
					throw new InvalidArgumentException('Directory "'.$this->conf['plugins_dir'].'" does not exist', 1);
				}
				if (!file_exists(t3lib_div::getFileAbsFileName($this->conf['plugins_dir']).'function.'.$name.'.php')) {
					# throw new \TYPO3\CMS\Core\Error\Http\ServiceUnavailableException('There is ('.$name.') no method with the given name to call', 1);
					throw new InvalidArgumentException('There is ('.$name.') no method with the given name to call', 1);
				}
				require_once(t3lib_div::getFileAbsFileName($this->conf['plugins_dir']).'function.'.$name.'.php');
				if (function_exists('phptemplate_plugin_' . $name)) { 
					array_unshift($args, $this); 
					return call_user_func_array('phptemplate_plugin_' . $name, $args); 
				} else {
					# throw new \TYPO3\CMS\Core\Error\Http\ServiceUnavailableException('There is ('.$name.') no method with the given name to call', 1);
					throw new InvalidArgumentException('There is ('.$name.') no method with the given name to call', 1);
				}
			#} elseif (in_array($name, $this->plugins_list)) {
			#	require_once(t3lib_extMgm::extPath('phptemplate').'plugins/class.'.$name.'.php');
			#	if (class_exists('phptemplate_plugin_' . $name)) { 
			#		// $this->$name = new 'phptemplate_plugin_' . $name;
			#		// array_unshift($args, $this); 
			#		// return call_user_func_array('phptemplate_plugin_' . $name, $args); 
			#	}
			} elseif (in_array($name, $this->plugins_list)) {
				#	// Class
				#if(file_exists(t3lib_extMgm::extPath('phptemplate').'plugins/class.'.$name.'.php')) {
				#	require_once(t3lib_extMgm::extPath('phptemplate').'plugins/class.'.$name.'.php');
				#	if (class_exists('phptemplate_plugin_' . $name)) { 
				#		#if (empty($this->$name)) {
				#			$this->$name = new phptemplate_plugin_form;
				#			return $this;
				#			// array_unshift($args, $this); 
				#			// return call_user_func_array('phptemplate_plugin_' . $name, $args); 
				#		#}
				#	}
				#}
				
					// Function
				if(file_exists(t3lib_extMgm::extPath('phptemplate').'plugins/function.'.$name.'.php')) {
					require_once(t3lib_extMgm::extPath('phptemplate').'plugins/function.'.$name.'.php');
					if (function_exists('phptemplate_plugin_' . $name)) { 
						array_unshift($args, $this); 
						return call_user_func_array('phptemplate_plugin_' . $name, $args); 
					}
				}
			}
			# throw new \TYPO3\CMS\Core\Error\Http\ServiceUnavailableException('There is ('.$name.') no method with the given name to call', 1);
			throw new InvalidArgumentException('There is ('.$name.') no method with the given name to call', 1);
		}
		 
		/*
			// Для плагинов
		public function __call($methodName, array $args)
		{
			if (array_search($methodName, $this->plugins_list)) {
				if (!is_callable('phptemplate_plugin_' . $methodName)) {
					throw new InvalidArgumentException('Second param must be callable');
				}
				// array_unshift($args, $this);
				return call_user_func_array('phptemplate_plugin_' . $methodName, $args);
			}
			throw RunTimeException('There is no method with the given name to call');
		}
		*/
	
		// Производим постоянный assign дефолтовых данных - поставкав шаблон осущесвтляется всегда
	protected function assign_default_varible() {
				
		// a) assign: Varigbles Page damp  // TSFE-pages
		$this->assign_varible['PAGE'] = $GLOBALS["TSFE"]->page; 
		$this->assign_varible['PAGE']['TSconfig'] = NULL; // для минимизации данных в print_r()

		// b) assign: Get data from cObj // default-data
		if ($this->cObj->data != $GLOBALS["TSFE"]->page) {
			if ($this->cObj->data['CType'] == "box" || $this->cObj->data['CType'] == "box_int") {
				$this->cObj->data['flexform_value'] = $this->xmlFlexFormConvert($this->cObj->data['flexform_value']); // конвертация гибких форм из коробки
			}
			$this->assign_varible['DATA'] = $this->cObj->data; 
		}
		
		
		// c) assign: Varigbles BE_USER damp
		if ($GLOBALS['TSFE']->beUserLogin == 1) {
			// $this->assign_varible['BE_USER_LOGIN'] = $GLOBALS["TSFE"]->beUserLogin; 
			$this->assign_varible['BE_USER'] = $GLOBALS["BE_USER"]->user; 
			$this->assign_varible['BE_USER']['password'] = NULL; // для безопасности 
			$this->assign_varible['BE_USER']['ses_data'] = NULL; // для минимизации данных в print_r()
			$this->assign_varible['BE_USER']['TSconfig'] = NULL; // для минимизации данных в print_r()
			$this->assign_varible['BE_USER']['uc'] = NULL; // для минимизации данных в print_r()
		} else {
			// $this->assign_varible['BE_USER_LOGIN'] = NULL; // все таки это не работает! (пока так и не понял причину)
		}
				
		// d) assign: Varibles FE_USER data
		if ($GLOBALS['TSFE']->loginUser == 1) {
			// $this->assign_varible['FE_USER_ISLOGIN'] = $GLOBALS['TSFE']->loginUser; 
			$this->assign_varible['FE_USER'] = $GLOBALS["TSFE"]->fe_user->user; 
			$this->assign_varible['FE_USER']['password'] = NULL; // для безопасности 
			$this->assign_varible['FE_USER_GROUP_DATA'] = $GLOBALS["TSFE"]->fe_user->groupData; 
		} else {
			// $this->assign_varible['FE_USER_ISLOGIN'] = 0; 
		}
				
		// e)-new! assign: Varigbles settings with convert settings. { ... }
		if (isset($this->conf['conf'])) {
			$this->assign_varible['CONF'] = $this->conf['conf']; 
		}
			
		// f) languageUid (текущий выбранный язык пользователем, а также код языка)
		/* zzz
		
				// Default Language on web site (ext manager - configuration)
			$confArrayPhpTemplate = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['phptemplate']);
			if (!empty($confArrayPhpTemplate['defLanguageUid'])){
				$defLanguageUid = $confArrayPhpTemplate['defLanguageUid'];
				if ($GLOBALS['TSFE']->sys_language_uid == 0){
					$row = t3lib_befunc::getRecord('sys_language',  $defLanguageUid, 'uid,flag');
					$this->assign_varible['t3_language_code'] = strtoupper($row[0]['flag']); 
					$this->assign_varible['t3_language_uid'] = $GLOBALS['TSFE']->sys_language_uid; 
				} else {
					$row = t3lib_befunc::getRecord('sys_language', $GLOBALS['TSFE']->sys_language_uid, 'uid,flag');
					$this->assign_varible['t3_language_code'] = strtoupper($row[0]['flag']); 
					$this->assign_varible['t3_language_uid'] = $GLOBALS['TSFE']->sys_language_uid; 
				}
			}
		*/
			
		// g) if Ajax mode // может пригодится для шаблонов (решил исключить из поддержки)
		if (!defined ('TYPO3_MODE_eIdAjax')) {
			// в данном режиме работает Ajax
			// $this->assign_varible['MODE_eIdAjax'] = 1; 
		} else {
			// $this->assign_varible['MODE_eIdAjax'] = 0; 
		}
		
		// h) _POST data (решил исключить из поддержки)
		if (isset($GLOBALS['_POST'])) {
			// $this->assign_varible['_POST'] = 1; 
		}
		
		// i) _GET data (решил исключить из поддержки)
		if (isset($GLOBALS['_GET'])) {
			// $this->assign_varible['_GET'] = 1; 
		}

	}

		// Для кибких форм - ищем vDEF-свойства и формируем массив
	public function xmlFlexFormConvert($xml) {
		$array = t3lib_div::xml2array($xml);			
		foreach ($array['data'] as $k1 => $v1) {
			foreach ($v1['lDEF'] as $k2 => $v2) {
				
					// Если это обычное свойство
				if (isset($v2['vDEF'])){
					$resultArray[$k2] = $v2['vDEF'];
				}
						
					// Если это секция
				$i = 0;
				if (isset($v2['el'])){
					foreach ($v2['el'] as $k3 => $v3) {
						$temp = $v3['default'];
						foreach ($temp as $k4 => $v4) {
							$skipIfHidden = 0;
							foreach ($v4 as $k5 => $v5) {
								if ($k5 == "hidden" && $v5['vDEF'] == 1) {
										// пропускем, если выключено
									$skipIfHidden = 1;
								}
									
								if ($skipIfHidden == 0) {
									$resultArray[$k2][$i][$k5] = $v5['vDEF'];
								}
							}
							$i++;
						}
					}
				}
					
			}
		}
		return $resultArray;
	}
	
		// Функция вывода результата
	protected function out() {
		$this->set_template_php_file();

		if (file_exists($this->path_template_php_file)) {
			ob_start();
				global $_AR;
				$_AR = $this->assign_varible;
				
					// Подключаем файл с настроечными переменными (если есть)
				$dirName = dirname($this->conf['template_file']);
				if(file_exists(PATH_site.$dirName.'/conf.php')) {
					require(PATH_site.$dirName.'/conf.php'); 
				}

					// Подключам файл с шаблоном
				require($this->path_template_php_file);

			$content = ob_get_clean();
		} else {
			$content = tx_phptemplate_error_wrap('Error path (' . $this->conf['template_file'] . ') template file!');
		}
		
		$content = $this->contentIfEmpty($content); 
		$content = $this->pi_wrapInBaseClass($content);
		return $content;
	}
	
		// Если возвращен пустой контент, верятно есть ошибка
	protected function contentIfEmpty($content) {
		if (trim($content) == null){
			return tx_phptemplate_error_wrap('Templete (' . $this->conf['template_file'] . ') send empty result!');
		} else {
			return $content;
		}
	}

	/**
	 * Wraps the input string in a <div> tag with the class attribute set to the prefixId.
	 * All content returned from your plugins should be returned through this function so all content from your plugin is encapsulated in a <div>-tag nicely identifying the content of your plugin.
	 *
	 * @param string $str HTML content to wrap in the div-tags with the "main class" of the plugin
	 * @return string HTML content wrapped, ready to return to the parent object.
	 * @todo Define visibility
	 */
	public function pi_wrapInBaseClass($content) {
	if (!$GLOBALS['TSFE']->config['config']['disablePrefixComment']) { // &&
			// !$GLOBALS['TSFE']->config['config']['disableAllHeaderCode']) {
			if ($this->prefixId == "tx_phptemplate_controller") {
				$content = '
<!--
	BEGIN: Content of extension "' . $this->extKey . '" (default controller), 
	template_file: ' . $this->conf['template_file'] . '
-->

' . $content . '

<!-- 
	END: Content of extension "' . $this->extKey . '" (default controller), 
	template_file: ' . $this->conf['template_file'] . '
-->
';
			} else {
				$content = '
<!--
	BEGIN: Content of extension "' . $this->extKey . '", 
	controller_file: ' . $this->conf['controller_file'] . ' (' . $this->prefixId . '),
	template_file: ' . $this->conf['template_file'] . '
-->

' . $content . '

<!-- 
	END: Content of extension "' . $this->extKey . '", 
	controller_file: ' . $this->conf['controller_file'] . ' (' . $this->prefixId . '),
	template_file: ' . $this->conf['template_file'] . '
-->
';
			}
		}
		return $content;
	}
	
	/*
		// Если явно указанна рабочая область: workOnSubpart
	protected function templateFileClipWorkOnSubpart() {
		if ($this->conf['workOnSubpart'] != null){
				
			// Создаем дирректорию - если ее не существует
			if( !is_dir( PATH_site . 'typo3temp/tx_phptemplate_workOnSubpart/' ) )
			mkdir(PATH_site . 'typo3temp/tx_phptemplate_workOnSubpart/');
					
					// Проверяем сущесттование файла сгенерированного по данной области во временной папке
				$filepath_fromt_TS = $this->conf['template_dir'] .  $this->conf['template_file'];
				if( !file_exists( PATH_site . 'typo3temp/tx_phptemplate_workOnSubpart/' . md5 ( $filepath_fromt_TS . "-" . $this->conf['workOnSubpart'] ) ) ){
					
						//Получаем значение шаблона рабочей области
					$template = file_get_contents ( PATH_site . $filepath_fromt_TS );
						
						// Вырезаем рабочую область: #DOCUMENT_BODY #DOCUMENT_BODY
					preg_match_all("/<!--([\s]*)###".$this->conf['workOnSubpart']."###([\s]*)-->(.*)<!--([\s]*)###".$this->conf['workOnSubpart']."###([\s]*)-->/isUu", $template,$arr);
				
							//Создаем файл // ("r" - считывать "w" - создавать "a" - добовлять к тексту), мы создаем файл
						$fp = fopen(PATH_site . 'typo3temp/tx_phptemplate_workOnSubpart/' . md5 ( $filepath_fromt_TS . "-" . $this->conf['workOnSubpart'] ), "w"); 
						fwrite($fp, $arr[3][0]);
						fclose (fp);
						
							//Итог - меняем значение пути на шаблон, сгенерированной рабочей области...
						$this->conf['template_file'] = PATH_site . 'typo3temp/tx_phptemplate_workOnSubpart/' . md5 ( $filepath_fromt_TS . "-" . $this->conf['workOnSubpart'] );
				
				} else {	
						//Просто меняем значение пути на шаблон, сгенерированной рабочей области...
					$this->conf['template_file'] = PATH_site . 'typo3temp/tx_phptemplate_workOnSubpart/' . md5 ( $filepath_fromt_TS . "-" . $this->conf['workOnSubpart'] );
				}
					
		}
	}
	*/
	



	
	/*******************************************
		Функции для использования в производных пользоватльских классах
		require_once(t3lib_extMgm::extPath('phptemplate').'pi1/class.tx_phptemplate_controller.php');
		class tx_phptemplate_controller_news extends tx_phptemplate_controller {
			function render($conf) {
				
			}
		}
	*/
	
	/*
		// А // это не рекомендуется использовать! 
		// Лучше писать что-то вроде "записи не найдены"
	public function pageNotFoundAndExit($msg){
		#ob_end_clean(); // очищает буфер вывода и отключает буферизацию вывода. // пока не понадобилось! (см. hook-и)
		# $GLOBALS['TSFE']->pageNotFoundAndExit($msg);
	}
		
		// B (использовать можно будет только в контроллере !)
		// для организации внутренней логики кэширования
	public function clearCacheThisPage(){
		$GLOBALS['typo3CacheManager']->getCache('cache_pages')->flushByTag('pageId_' . $GLOBALS['TSFE']->id);
	}
	
		// C BETA (использовать можно будет только в контроллере !)
		// для организации внутренней логики кэширования
	public function clearCacheAllPages(){
		$GLOBALS['typo3CacheManager']->getCache('cache_pages')->flush();
	}
	*/
	
		// D BETA (использовать можно будет только в контроллере !)
		// для организации внутренней логики кэширования
	# public function addCachePageTag($tag, $value){
	#	$GLOBALS['TSFE']->addCacheTags(array($tag . '_' . $value)); 
	# }
	
		// E BETA (использовать можно будет только в контроллере !)
		// для организации внутренней логики кэширования
	# public function clearCachePageByTag($tag, $value){
	#	$GLOBALS['typo3CacheManager']->getCache('cache_pages')->flushByTag($tag . '_' . $value);
	# }
	
		// F BETA (использовать можно будет только в контроллере !)
		// для организации внутренней логики кэширования
	// beta - public function clearCacheThisPlugin(){}	// пока не знаю что это...

		// Изменить/добавить параметры настроек
	public function set_conf($varible, $value){
		$this->conf[$varible] = $value;
	}
	
		// Изменить/устанавливаем путь к php-шаблону
	public function set_template_php_file($path_value) {
		if (isset($path_value)) {
			$this->conf['template_file'] = $path_value;
		}
		
		$this->path_template_php_file = t3lib_div::getFileAbsFileName($this->conf['template_file']);
		$GLOBALS['tx_phptemplate_func_tplPath'] = $this->path_template_php_file; // for func.php __tplPath__()
	}
	
		// Функция регистрации плагина // beta
	public function regiser_plugin($pathPlugin) {
		//
	}
	
		// Функция регистрации переменной
	public function assign($varible_name, $varible_value) {
		$this->assign_varible['MY'][$varible_name] = $varible_value;
	}
	
		// Функция для внесения изменений
	public function render($content, array $conf) {	
		#  $this->...
	}
	
		// Функция создает папку для записи маркеров локализации (расширение EXT: xDbMySQL)
		// Маркеры пишутся через функцию ___LLL___()
	public function create_localization_folder(){
		// Не актуально
	/*
		$GLOBALS['tx_phptemplate_func_LLL'] = $this->conf['template_file']; // сохраняем путь к шаблону
		$res = $GLOBALS['TYPO3_DB']->sql_query('SELECT `key_path_template` FROM `tx_web_localization` WHERE `key_path_template` = "'.$this->conf['template_file'].'" LIMIT 1');
		if($GLOBALS['TYPO3_DB']->sql_num_rows($res) == 0){
				// Создаем папку
			$insertArray = array(
				'title' => $this->conf['template_file'],
				'key_path_template' => $this->conf['template_file'],
				'telem' => 'directory'
			);
			$query = $GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_web_localization', $insertArray);			
		} else {
			// $row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) 
		}
	*/
	}
	
	/*
		Beta
		public function before(){} // возможно и не нужно!
		public function after(){} // возможно и не нужно!
		$this->tools = // beta сюда можно будет загрузить функции почтовых шаблонов из xDbMySQL
		$this->tools->fileGetContents();
		$this->db->table('') = // beta сюда можно в принципе подгрузить DB::run() - хотя скорее всего оставлю так
	*/

}

?>