<?php
//http://framework.zend.com/manual/1.12/ru/zend.validate.set.html
/*
API для валидации форм (проверка данных на валидность)

->req()                          // Обязательное поле 
->len(3,28)                          // Диапазон чисел 
->min(1)                             // Минимальный размер строки 
->max(5)                             // Максимальный размер строки 
->minItems(1)                        // Минимальное кол-во выбранных элементов (для массивов) 
->maxItems(100)                  // Максимальное кол-во выбранных элементов (для массивов) 
->compare('fieldA', 'fieldB')        // Максимальное кол-во выбранных элементов (для массивов) 
->valid_url() 
->valid_email() 
->valid_phone() 
->valid_ip() 
->valid_date() 
->only_int() 
->only_float() 
->only_string() 
->in(array('допустипое значение 1','допустипое значение 2')) 
->regex('/[0-9]+/is') 
->captcha()                          // Защита от спама (проверяется с использованием сессии) 
  
    // Beta 
->userFunc($this->validIp, function() { return FALSE; } ) // Пользвоательская функция // пользовательская проверка даже правильнее будет 
->unique() - beta                        // Проверка на уникальность значения в БД 
->allowFileType(), maxFileSize()     // Проверка типов и размеров прикрепляемых файлов  


    // Валидация формы, получение значения капчи из БД 
$pRecordvalue = t3lib_befunc::getRecord('tx_web_settings', 1, 'ajax_plugin_feedback_cprotected'); 
$validator = DBTOOLS::strvalidator(); 
$validator->load_data_array($GLOBALS['_POST']['tx_phptemplate_form_ask_a_question']); 
$validator->set_rules('username', 'Имя', 'пустое значение.')->req(); // "Ваше имя, псевдоним" 
$validator->set_rules('username', 'Имя', 'больше 32 символов.')->max(32); // "Ваше имя, больше 32 символов" 
$validator->set_rules('email', 'Почта', 'указан не правильно.')->valid_email(); // Проверка email-почты 
$validator->set_rules('subject', 'Тема сообщения', 'не выбрана.')->req(); // "Тема сообщения" 
$validator->set_rules('commentary', 'Комментарий', 'сообщение малоинформативно.')->min(10); // "Комментарий к звонку" 
// устаревший вариант $validator->set_rules('captcha', 'Капча', 'не верный код.')->captcha($pRecordvalue['ajax_plugin_feedback_cprotected']); // "Проверка: чему будет равно (2+7)-5*"+ 
$validator->set_rules('telephone', 'Телефон', 'Формат телефона указан не правильно')->valid_phone(); 
      
    // Если нет ошибок 
if ($validator->exam() == TRUE) { 
  
        // Получаем из.глоб.настроек emeil-адрес //tx_web_settings 
    $emailTo = t3lib_befunc::getRecord('tx_web_settings', 1, "email_admin"); 
                  
        // Отправляем письмо  
    $mail = DBTOOLS::mail(); 
    $mail->setMarker( 
        array( 
        "username"      => $GLOBALS['_POST']['tx_phptemplate_form_ask_a_question']['username'], 
        "email"         => $GLOBALS['_POST']['tx_phptemplate_form_ask_a_question']['email'], 
        "commentary"    => $GLOBALS['_POST']['tx_phptemplate_form_ask_a_question']['commentary'], 
        "subject"       => base64_decode($GLOBALS['_POST']['tx_phptemplate_form_ask_a_question']['subject']), 
        ) 
    ); 
    $mail->templateId('FORM_ASKAQUESTION'); 
    $mail->setTo($emailTo['email_admin']); // i-litovan@yandex.ru 
    $mail->send(); 
              
    ?> 
        <span style="color: green"> 
            Спасибо за использование формы "Задать вопрос".  
            Если вопрос предполагает обратный ответ - в ближайщее время наши сотрудники свяжутся с Вами. 
        </span> 
    <? 
              
} else { 
  
            // Получаем ошибки (если есть) 
        $arError = $validator->get_errors();  
        ?> 
                  
            <form method="post" data-ajax=true> 
  
                <b style="color: green;">Форма - задать вопрос</b><br /><br /> 
                  
            <hr> 
            <?php print $arError['telephone']; ?> 
            <input type="text" style="width: 15%;" name="tx_phptemplate_form_ask_a_question[telephone]" value="<?php print $this->safeValue($GLOBALS['_POST']['tx_phptemplate_form_ask_a_question']['telephone']); ?>" class="input-xlarge" placeholder="7"> 
            <hr> 
              
                Ваше имя*: <!--Если есть ошибки--><span style="color: red;"><?php print $arError['username']; ?></span><br /> 
                <input  type="text" name="tx_phptemplate_form_ask_a_question[username]" class="resetvalue" 
                value="<?php print $this->safeValue($GLOBALS['_POST']['tx_phptemplate_form_ask_a_question']['username']); ?>" 
                size="32" maxlength="32" autofocus><br /> 
                  
                <!--<span style="color: gray;">Как к вам обращаться...</span><br />--> 
                <br />     
                  
                E-mail*: <!--Если есть ошибки--><span style="color: red;"><?php print $arError['email']; ?></span><br /> 
                <input type="text" name="tx_phptemplate_form_ask_a_question[email]" class="resetvalue" 
                value="<?php print $this->safeValue($GLOBALS['_POST']['tx_phptemplate_form_ask_a_question']['email']); ?>" 
                data-default="+7 (916) 000-00-00" size="25" maxlength="20"><br /> 
                <span style="color: gray;">Пример: info@yoursite.ru</span><br /> 
                <br />     
                  
                Тема сообщения*: <!--Если есть ошибки--><span style="color: red;"><?php print $arError['subject']; ?></span><br /> 
                <select name="tx_phptemplate_form_ask_a_question[subject]"> 
                    <option value="">--</option> 
                    <!--Считываем из БД - таблицы настроек--> 
                    <!--Записываем в smarty-переменную и разбиваем ее построчно--> 
                    <?php 
                        $subjectList = $this->getSource('DB:tx_web_settings:1:ajax_plugin_ask_a_question_subject_list'); 
                        $subjectList = explode("\n", $subjectList); 
                        foreach ($subjectList as $k => $v) { 
                            if ($GLOBALS['_POST']['tx_phptemplate_form_ask_a_question']['subject'] == base64_encode($v)) { 
                                print '<option value="'.base64_encode($v).'" selected>'.$v.'</option>'; 
                            } else { 
                                print '<option value="'.base64_encode($v).'">'.$v.'</option>'; 
                            } 
                        } 
                    ?> 
                </select> 
                <br /><br />     
                  
                Ваше сообщение*: <!--Если есть ошибки--><span style="color: red;"><?php print $arError['commentary']; ?></span><br /> 
                <textarea name="tx_phptemplate_form_ask_a_question[commentary]" class="resetvalue"
                style="width: 220px; height: 72px;"><?php print $this->safeValue($GLOBALS['_POST']['tx_phptemplate_form_ask_a_question']['commentary']); ?></textarea><br /> 
                <br /> 
                  
                Защита от спама*: <!--Если есть ошибки--><span style="color: red;"><?php print $arError['captcha']; ?></span> 
                <br />чему будет равно <?php print $this->getSource('DB:tx_web_settings:1:ajax_plugin_feedback_cprotected'); ?>= 
                <input type="text" name="tx_phptemplate_form_ask_a_question[captcha]" 
                value="<?php print $this->safeValue($GLOBALS['_POST']['tx_phptemplate_form_ask_a_question']['captcha']); ?>" size="5" maxlength="2"><br /> 
                  
                * - отмечанные обязательные поля 
                <br /> 
                <input type="submit" value="Задать вопрос"> 
  
            </form> 
          
        <? 
          
} // end if 
?> 

*/

class phptemplate_plugin_class_validator {

	var $formKeyId = ""; // Ключ формы
	var $result; // Переменная с результатами
	
	#function __construct() {
	#	if(!empty($GLOBALS['_POST']['formKeyId'])){
	#		$this->formKeyId = $GLOBALS['_POST']['formKeyId'];
	#	}
	#}
	
	//var $_string_validation_last_position = ""; // содержит имя проверяемой строки
	//var $_string_validation_last_value = ""; // содержит содержимое проверяемой строки
	
	//var $_errorList = array(); // список ошибок (коды)
	//var $_errorListMsg = array(); // список ошибок (сообщения)
	//var $_field_data = array(); // список данных для проверки
	# var $_field_rules_list = array(); // список правил для поля

	/**
	 * 
	 * Загрузка данных для проверки 
	 * @param array
	 */
	/*
	function load_data_array($array) {
		if (count($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_field_data']) == 0) {
			$GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_field_data'] = $array;
		}
		# elseif (count($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_field_data']) > 0) {
		#	$GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_field_data'] += $array;
		# } else {
		# 
		# }
		# print_r($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_field_data']);
		return $this;
	}
	*/
	
	/** NEW
 	 * 
 	 * Сброс формы в первоначальное состояние
 	*/
	/*
	function reset() {
		$this->formKeyId = NULL;
		$this->result = NULL;
		
		#$this->ZZZ_string_validation_last_position = ""; // содержит имя проверяемой строки
		#$this->ZZZ_string_validation_last_value = ""; // содержит содержимое проверяемой строки
	
		#$this->ZZZ_errorList = array(); // список ошибок (коды)
		#$this->ZZZ_errorListMsg = array(); // список ошибок (сообщения)
		#$this->ZZZ_field_data = array(); // список данных для проверки
		return $this;
	}
	*/
	
	/**
	 * 
	 * Загрузка данных для проверки из _POST массива, если нажата соответствующая <input type="submit" с ключем name="">
	 * @param array (исключено - _POST-по умолчанию...)
	 * @param formKeyValue
	 */
	// function load_post_data_array_with_formKey($formKeyIdValue = "form_name_id") {
	function load($keyId = "form_default") {
	
		/*
		if ($GLOBALS['_POST']['formKeyId'] == $formKeyIdValue) {
			$this->formKeyId = $GLOBALS['_POST']['formKeyId'];
			$GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId] = NULL;
			
			$array = $GLOBALS['_POST'];
			if(count($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_field_data']) == 0) {
				$GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_field_data'] = $array;
			}
		}
		*/
		#if ($GLOBALS['_POST']['formKeyId'] == $formKeyIdValue) {
		# if(isset($GLOBALS['_POST'][''])){
			// $this->formKeyId = $GLOBALS['_POST']['formKeyId'];
			$this->formKeyId = $keyId;
			// $GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId] = NULL;
			
			$array = $GLOBALS['_POST'];
			if(count($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_field_data']) == 0) {
				$GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_field_data'] = $array;
			}
		# }
		
		# elseif (count($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_field_data']) > 0) {
		#	$GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_field_data'] += $array;
		# } else {
		# 
		# }
		# print_r($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_field_data']);
		return $this;
	}
	
			/** NEW
			 * 
			 * Проверяем, отпраленны ли _POST-данные?
			 */
			function is_submit() {
				if(!empty($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_field_data'])){
					return TRUE;
				} else {
					return FALSE;
				}
			}
	
	/**
	 * 
	 * Получить ошибки
		get_string_errors() - возвращает все сообщения об ошибках в виде строки
		get_array_errors() - возвращает все сообщения в виде массива, где в качестве ключа используется имя поля, а в качестве значения — описание ошибки для этого поля.
		form_error($field) — возвращает сообщение об ошибке для поля, переданного в качестве параметра $field
	 */
	function get_errors() {
		$tempErrorList = array();
		foreach ($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorList'] as $key => $value) {
			$tempErrorList[$key]['label'] = $GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorListMsg'][$key]['label'];
			$tempErrorList[$key]['msg'] = $GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorListMsg'][$key]['msg'];
		}
		return $tempErrorList;
		# return $GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorList'];
		
	}
	
		/** NEW
		 * 
		 * Получить кол-во ошибок
		 */
		function get_count_error($fieldName = NULL){
				// Если указано конкретное поле
			if(!empty($fieldName)){
				$i = 0;
				if(count($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorList'][$fieldName]) > 0){
					$i = $i + count($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorList'][$fieldName]);
				}
			} else {
				$i = 0;
				foreach($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorList'] as $k => $v){
					if(count($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorList'][$k]) > 0){
						$i = $i + count($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorList'][$k]);
						//break;
					}
				}
			}
			return $i;
		}
	
	/**
	 * 
	 * Загрузка данных для проверки
	 * @param string
	 * @param string
	 * @param string
	 */
	function set_rules($fieldName, $label = "", $msg = "") {
		# $this->_field_rules_list[$fieldName];
		$GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_position'] = $fieldName;
		$GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'] = $GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_field_data'][$fieldName];
		
		if (!empty($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_field_data'])) {
			# if (!isset($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorListMsg'][$fieldName]) && !isset($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorList'][$GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_position']])) {
			if (!isset($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorList'][$GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_position']])) {
				$GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorListMsg'][$fieldName]['label'] = $label;
				$GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorListMsg'][$fieldName]['msg'] = $msg;
			}
		}
		return $this;
	}
	
	/**
	 * 
	 * Добавить сообщение об ошибке
	 * @param array
	 */
	# $validator->set_rules('commentary', 'Комментарий',)->min(10)->set_msg_error('commentary', '', 'сообщение малоинформативно.'); // "Комментарий к звонку"
	# function set_msg_error($fieldName, $label, $msg) {
	#	# $this->_field_rules_list[$fieldName];
	#	return $this;
	# }
	
	/**
	 * 
	 * Стартовая конструкция
	 * @param string
	 */
	# function main($str) {
	#	$GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_position'] = $str;
	#	return $this;
	# }
	
	/**
	 * 
	 * Сборка результата
	 * @param str
	 * @param flag
	 */
	function __result__($func_name, $valid = FALSE) {
		if ($valid == TRUE) {
			$GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorList'][$GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_position']][$func_name] = TRUE;
			// $GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorList'][$func_name] = TRUE;
		} else {
			// $GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorList'][$func_name] = FALSE; // ошибок нет
		}
	}
	
	/**
	 * 
	 * Объединение общего результата результата
	 * @param str
	 * @param flag
	 */
	function exam() {
		if (empty($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_field_data'])) {
			$GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorList'] = NUll;
			return FALSE;
		} elseif (count($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorList']) > 0) {
			# return "<pre>" . print_r($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorList'],true) . "</pre>";
			# return $GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorList'];
			return FALSE;
		} else {
			return TRUE; // ошибок нет
		}
		
	}
	
		/** NEW
		 * 
		 * Проверяем поле на наличие ошибок
		 */
		function is_valid() {
			$fieldName = $GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_position'];
			if(count($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorList'][$fieldName]) == 0) {
				return TRUE;
			} else {
				return FALSE;
			}
		}
		
		/** NEW
		 * 
		 * Установка ошибок (название ошибки)
		 */
		function set_error_label($fieldName, $content) {
			$GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorListMsg'][$fieldName]['label'] = $content;
		}
		
		/** NEW
		 * 
		 * Установка ошибок (конкретная ошибка для правила)
		 */
		function set_error_messege($fieldName, $rule, $content) {
			$GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_errorListMsg'][$fieldName]['msg']["error-".$rule] = $content;
		}
	
	/**
	 * 
	 * Обязательное поле
	 * @param string
	 */
	function req() {
		if (empty($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'])){
			$this->__result__('error-req', TRUE);
		}
		return $this;	
	}
	
	/**
	 * 
	 * Минимальная длинна строки
	 * @param string
	 */
	function min($val) {
		if (mb_strlen($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'], 'UTF-8') < $val){
			$this->__result__('error-min', TRUE);
		}
		return $this;	
	}

	/**
	 * 
	 * Максимальная длинна строки
	 * @param string
	 */
	function max($val) {
		if (mb_strlen($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'], 'UTF-8') > $val){
			$this->__result__('error-max', TRUE);
		}
		return $this;	
	}
	
	/**
	 * 
	 * Минимальное кол-во выбранных элементов
	 * @param array
	 */
	function minItems($valArr = 1) {
		if (count($valArr) < $valArr){
			$this->__result__('error-minItems', TRUE);
		}
		return $this;	
	}

	/**
	 * 
	 * Максимальная кол-во выбранных элементов
	 * @param array
	 */
	function maxItems($valArr = 100) {
		if (count($valArr) > $valArr){
			$this->__result__('error-maxItems', TRUE);
		}
		return $this;	
	}
	
	/**
	 * 
	 * Диапазон длинный строки
	 * @param string
	 */
	function len($min, $max) {
		if (
			mb_strlen($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'], 'UTF-8') < $min
			OR 
			mb_strlen($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'], 'UTF-8') > $max
		){
			$this->__result__('error-len', TRUE);
		}
		return $this;	
	}
	
	/**
	 * 
	 * Совпадение с другим полем
	 * @param string
	 */
	function compare($fieldName_1, $fieldName_2) {
		if ($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_field_data'][$fieldName_1] != $GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_field_data'][$fieldName_2]){
			$this->__result__('error-compare', TRUE);
		}
		return $this;	
	}

	/**
	 * Валидация URL
	 * @param string
	 */
	function valid_url() {
		$temp = filter_var($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'], FILTER_VALIDATE_URL);
		if ($temp == FALSE) {
			$this->__result__('error-url', TRUE);
		}
		return $this;	
	}
	
	/**
	 * 
	 * Валидация Email-адреса
	 * @param string
	 */
	function valid_email() {
		$temp = filter_var($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'], FILTER_VALIDATE_EMAIL);
		if ($temp == FALSE) {
			$this->__result__('error-email', TRUE);
		}
		return $this;
	}

	/**
	 * 
	 * Валидация телефона
	 * @param string
	 */
	function valid_phone() {
/*
	Поддерживаемые форматы телефонов:
		555 555 5555
		(555) 555-5555
		(555)555-5555
		555-555-5555
		555.555.5555
		5555555555
		0-000-000-0000
		0.000.000.0000
		0 000 000 0000
		00000000000
		+0-000-000-0000
		+0.000.000.0000
		+0 000 000 0000
		+00000000000
*/
	// Решил отказаться от всего этого, т.к. могут указать доб. телефон и прочие символы
	// Просто ставим проверку на Max 42.

		if (
		mb_strlen($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'], 'UTF-8') < 5
		||
		mb_strlen($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'], 'UTF-8') > 42
		){
			$this->__result__('error-phone', TRUE);
		}
		return $this;	
	
		// $temp = preg_match( '/^[+]?([\d]{0,3})?[\(\.\-\s]?([\d]{3})[\)\.\-\s]*([\d]{3})[\.\-\s]?([\d]{4})$/', $GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'] );
		// if ($temp == FALSE) {
		// 	$this->__result__('error-phone', TRUE);
		// }
		// return $this;
	}
	
	/**
	 * 
	 * Валидация IP-адреса
	 * @param string
	 */
	function valid_ip() {
		$temp = filter_var($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'], FILTER_VALIDATE_IP);
		if ($temp == FALSE) {
			$this->__result__('error-ip', TRUE);
		}
		return $this;
	}

	/**
	 * Проверка даты
	 * @param string
	 */	
	function valid_date(){
		$str = $GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'];
		$stamp = strtotime($str);

		if (!is_numeric($stamp) OR trim($stamp) == NULL){
			$this->__result__('error-date',  TRUE);
			return $this;
		}
		
		$month = date( 'm', $stamp );
		$day   = date( 'd', $stamp );
		$year  = date( 'Y', $stamp );
		
		$temp = checkdate($month, $day, $year);
		if ($temp == FALSE) {
			$this->__result__('error-date', TRUE);
		}
		return $this;
	}

	/**
	 * Проверка поля на целое цисло
	 * Проверка поля на цисло c плавающей точкой
	 * Только буквы латинского алфавита
	 *
	 * @access	public
	 * @param	string
	 * @return	bool
	 */		
	function only_chars($type_string) {
		switch( $type_string ) {
			case 'int':
				$temp = filter_var($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'], FILTER_VALIDATE_INT);
				if ($temp == FALSE) {
					$this->__result__('error-only-chars', TRUE);
					$this->__result__('error-only-chars-type-int', TRUE);
				}
				break;
			
			case 'float':
				$temp = filter_var($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'], FILTER_VALIDATE_FLOAT);
				if ($temp == FALSE) {
					$this->__result__('error-only-chars', TRUE);
					$this->__result__('error-only-chars-type-float', TRUE);
				}
				break;
				
			case 'string':
				$temp = preg_match("/^[\w\d\s.,-]*$/", $GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'], $matches);
				if ($temp == FALSE) {
					$this->__result__('error-only-chars', TRUE);
					$this->__result__('error-only-chars-type-string', TRUE);
				}
				break;
			/*
				if(
					! preg_match("/^[\w\s]*$/ui", $GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value']) 
					OR
					preg_match("/[0-9]/", $GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'])
				) {
					$this->__result__('error-only-chars', TRUE);
					$this->__result__('error-only-chars-type-letters', TRUE);
				}
				break;
			*/
			default:
					# $this->__result__('error-only-chars', TRUE);
					# $this->__result__('error-only-chars-unknown-type-string', TRUE);
				break;
		}
		return $this;
	}
	
		/**
		 * Функции-дублеры
		 *
		 * @param	string
		 * @return	object
		 */		
		# function only_chars_int() {
		function only_int() {
			return $this->only_chars('int');
		}
		# function only_chars_float($math) {
		function only_float($math) {
			return $this->only_chars('float');
		}
		# function only_chars_letters($math) {
		function only_string($math) {
			return $this->only_chars('string');
		}
	
	/**
	 * Проверка капчи (матем. формула)
	 * @param string
	 */	
	function captcha($val) {
		/* СТАРЫЙ ВАРИАНТ - проверка на числа
		eval("\$temp = ".$val.";");
		if ($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'] != $temp){
			$this->__result__('error-captcha', TRUE);
		}
		return $this;
		*/
		if($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'] != $_SESSION['digit']){
			if(!isset($_SESSION)) {
				session_start();
			}
			$this->__result__('error-captcha', TRUE);
			unset($_SESSION['digit']);
		}
		return $this;
	}
	
	/**
	 * Обязательно наличие данных значений "->in(array('допустипое значение 1','допустипое значение 2')"
	 * @param string
	 */	
	function in($arr) {
		if (is_array($arr)) {
			if (!in_array($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'], $arr)) {
				$this->__result__('error-in', TRUE);
			}
		}
		return $this;
	}

	/**
	 * Регулярное выражение
	 * @param string
	 */	
	function regex($str) {
		$regex = $str;
		if(! preg_match($regex, $GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value'])){
			$this->__result__('error-regex', TRUE);
		}
		return $this;
	}
	
	/**
	 * Пользовательская функция
	 * @param array
	 */	
	function userFunc($func = NULL) {
		if (!function_exists($func) ) {
			$this->__result__('error-userFunc' . $value, TRUE);
			$this->__result__('error-userFunc-not-exists' . $value, TRUE);
		} else {
			$return_func = $func($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value']);
			$ar_errorList = $return_func;

			if (is_array($ar_errorList)) {
				foreach ($ar_errorList as $key => $value) {
					if ($value == FALSE) {
						$this->__result__('error-userFunc' . $value, TRUE);
						$this->__result__('error-userFunc-' . $value, TRUE);
					}
				}
			} else {
				if ($ar_errorList == FALSE) {
					$this->__result__('error-userFunc' . $value, TRUE);
				}
			}
		}
		return $this;
	} 
	
	/**
	 * Пользовательский класс
	 * @param array
	 */	
/*
	# print "<tr><td>Пользовательский класс</td><td>" .DBTOOLS::VALIDATOR('56')->userClass('tx_test::test')->exam() . "</td></tr>"; 
	function userClass($class = NULL) {
		$class = explode("::", $class);

			$_className = $class[0];
			$_methodName = $class[1];
		
		if (!class_exists($_className) ) {
			$this->__result__('error-userClass' . $value, TRUE);
			$this->__result__('error-userClass-class-not-exists' . $value, TRUE);
			
			if(method_exists($_className, $_methodName)){
				$this->__result__('error-userClass' . $value, TRUE);
				$this->__result__('error-userClass-method-not-exists' . $value, TRUE);
			}

		} else {
			$return_class = $_className::$_methodName($GLOBALS['tx_phptemplate_class_validator_result'][$this->formKeyId]['_string_validation_last_value']);
			$ar_errorList = $return_class;

			if (is_array($ar_errorList)) {
				foreach ($ar_errorList as $key => $value) {
					if ($value == FALSE) {
						$this->__result__('error-userClass' . $value, TRUE);
						$this->__result__('error-userClass-' . $value, TRUE);
					}
				}
			} else {
				if ($ar_errorList == FALSE) {
					$this->__result__('error-userClass' . $value, TRUE);
				}
			}
		}
		return $this;
	} 
*/
	
	/**
	 * Проверка значения на уникальность в таблице
	 * @param str
	 * @param fields
	 * @param additionalWhereClause (beta)
	 * @param link_connect
	 */	
	/*
	function unique($str,$fields,$additionalWhereClause = array()) {
		list($table,$field) = explode('.',$fields);
		$rows = DB::run()->table($table)->select($field)->where($field, "=", $str);
		if (count($rows) > 0) {
			$this->__result__('error-unique', TRUE);
		}
		return $this;
	}
	*/
	
}