<?php
/*
	plugin getFileInfoWithReference() only TYPO3 6.0+
	Select file info from "sys_file_reference" and "sys_file"
	@ tablenames
	@ fieldname
	@ record_id
*/
function phptemplate_plugin_getFileInfoWithReference($self, $tablenames = "pages", $fieldname = "media", $record_id = null) {

	if (version_compare(TYPO3_branch, '6.0', '<')) {
		return tx_phptemplate_error_wrap("Plugin getFileInfoWithReference() only TYPO3 6.0+");
	}
		
		// 1. select all file storage from "sys_file_storage"
	$storageList = array();
	if ($GLOBALS['tx_phptemplate_temp']['sys_file_storage_list'] == NULL) {
		$qStorage = DB::run();
		$qStorage->table("sys_file_storage");
		$qStorage->select('uid,configuration');
		$rowsStorage = $qStorage->exec();
			
			foreach ($rowsStorage as $k => $v) {
				$storageList[$v['uid']] = $v;
				
				preg_match_all('#<value index="vDEF">(.+?)</value>(\s+?)#is', $v['configuration'], $matches);
				$storageList[$v['uid']]['configuration_basePath'] = $matches[1][0];
				$storageList[$v['uid']]['configuration_pathType'] = $matches[1][1];
			}

			// Save varible
		$GLOBALS['tx_phptemplate_temp']['sys_file_storage_list'] = $storageList;		
	} else {
		$storageList = $GLOBALS['tx_phptemplate_temp']['sys_file_storage_list'];
	}

		// 2. select from sys_file_reference
	if ($record_id == "_self") {
		$record_id = $GLOBALS['TSFE']->id;
	}
	$q = DB::run();
	$q->table("sys_file_reference");
	$q->select('uid_local,title,description,alternative,link');
	$q->where("tablenames", "=", $tablenames);
	$q->where("fieldname", "=", $fieldname);	
		if ($record_id > 0) {
			$q->where("uid_foreign", "=", $record_id);
		}
	$rowsReference = $q->exec();
		
		// 3. select file info from sys_file
	$resultArrayList = array();
	$uidListSysFileRef = array();
	$sysFileRef = array();
	$sysFileListWithKeyId = array();
	for ($i = 0; $i <= count($rowsReference)-1; $i++) {
		$uidListSysFileRef[] = $rowsReference[$i]['uid_local'];
	}

	$q2 = DB::run();
	$q2->table("sys_file");
	$q2->select("uid,type,storage,identifier,extension,mime_type,name,title,size,width,height,description,alternative");
	$q2->whereIn("uid", $uidListSysFileRef);
	$q2->orderFindInSet("uid", $uidListSysFileRef);
	$rows = $q2->exec();

	for ($i = 0; $i <= count($rows)-1; $i++) {
		$sysFileListWithKeyId[$rows[$i]['uid']] = $rows[$i];
	}
	
	for ($i = 0; $i <= count($rowsReference)-1; $i++) {
		$idSysFile = $rowsReference[$i]['uid_local'];
		$dataFromSysFileTable = $sysFileListWithKeyId[$idSysFile];
		
		$resultArrayList_temp = array();
		$resultArrayList_temp = $rowsReference[$i];
			
			// change data
		if ($resultArrayList_temp['title'] == null) {
			$resultArrayList_temp['title'] = $dataFromSysFileTable['title'];
		}
		if ($resultArrayList_temp['description'] == null) {
			$resultArrayList_temp['description'] = $dataFromSysFileTable['description'];
		}
		if ($resultArrayList_temp['alternative'] == null) {
			$resultArrayList_temp['alternative'] = $dataFromSysFileTable['alternative'];
		}
			
			// oher data
		$resultArrayList_temp['mime_type'] = $dataFromSysFileTable['mime_type'];
		$resultArrayList_temp['extension'] = $dataFromSysFileTable['extension'];
		$resultArrayList_temp['size'] = $dataFromSysFileTable['size'];
		$resultArrayList_temp['name'] = $dataFromSysFileTable['name'];

			// remove first "/" slash
		$resultArrayList_temp['identifier'] = trim($dataFromSysFileTable['identifier'], '/'); 

			// add storage path
		$resultArrayList_temp['storage'] = $dataFromSysFileTable['storage'];
		$resultArrayList_temp['path'] = $storageList[$dataFromSysFileTable['storage']]['configuration_basePath'] . $resultArrayList_temp['identifier'] ;
		

			// save
		$resultArrayList[] = $resultArrayList_temp;
	}
	
	# $self->print_r($resultArrayList);

		// return result
	return $resultArrayList;
}
?>