<?php
/*
	@ idMarker
	@ title
	@ editIconDisplay
	@ returnError
*/
require_once ( t3lib_extMgm::extPath('phptemplate') . "plugins/function.editIcon.php" );
require_once ( t3lib_extMgm::extPath('phptemplate') . "plugins/function.tsFormat.php" );
function phptemplate_plugin_getMarker($self, $idMarker = 0, $title = NULL, $editIconDisplay = FALSE, $returnError = TRUE) {
	/**
		Извлекаем маркер из таблицы "tx_air_table_marks" (air_tables)
		* bodytext - если включен визуальный редактор, прогоняем его через parse_RTE
	*/

	$row = DB::run()->table('tx_air_table_marks')->select("uid,telem,string,bodytext,bodytext_with_rte,image_1,images,file_1,files,link_parameter,typoscript_code,flexform_value")->whereIdRecord($idMarker)->limit(1)->exec();
	
		// Маркер не найден
	if ($row[0]['uid'] == 0) {
		if ($returnError == TRUE) {
			return tx_phptemplate_error_wrap('Marker with id "'.$idMarker.'" not found!');
		} else {
			return "";
		}
	} else {
		
			// В зависимости от типа маркера
		switch($row[0]['telem']) {
			case 'string':
					phptemplate_plugin_getMarker_editIconWrap($idMarker, $title, $editIconDisplay);
					return $row[0]['string'];
				break;
			case 'text':
					phptemplate_plugin_getMarker_editIconWrap($idMarker, $title, $editIconDisplay);
					return $row[0]['bodytext'];
				break;
			case 'text_with_rte':
					phptemplate_plugin_getMarker_editIconWrap($idMarker, $title, $editIconDisplay);
					return $self->tsFormat($row[0]['bodytext_with_rte']);
				break;
			case 'image_1':
					phptemplate_plugin_getMarker_editIconWrap($idMarker, $title, $editIconDisplay);
					return $row[0]['image_1'];
				break;
			case 'images':
					phptemplate_plugin_getMarker_editIconWrap($idMarker, $title, $editIconDisplay);
					return $row[0]['images'];
				break;
			case 'file_1':
					phptemplate_plugin_getMarker_editIconWrap($idMarker, $title, $editIconDisplay);
					return $row[0]['file_1'];
				break;
			case 'files':
					phptemplate_plugin_getMarker_editIconWrap($idMarker, $title, $editIconDisplay);
					return $row[0]['files'];
				break;
			case 'link':
					phptemplate_plugin_getMarker_editIconWrap($idMarker, $title, $editIconDisplay);
					return $row[0]['link_parameter'];
				break;
			case 'ts':
					phptemplate_plugin_getMarker_editIconWrap($idMarker, $title, $editIconDisplay);
					
							// Ts parse
						$tsParser = t3lib_div::makeInstance('t3lib_TSparser');
						$tsParser->parse( $row[0]['typoscript_code'] );
						$tsConf = $tsParser->setup; // result
					
					return $self->cObj->cObjGetSingle("COA", $tsConf); // . rand(1,1000) ;
				break;
			case 'flexform':
					phptemplate_plugin_getMarker_editIconWrap($idMarker, $title, $editIconDisplay);
					$row[0]['flexform_value'] = $self->xmlFlexFormConvert($row[0]['flexform_value']);
					return $row[0]['flexform_value'];
				break;
		}
		
	}
}

	// Здесь делается print а не return
function phptemplate_plugin_getMarker_editIconWrap($idMarker, $title = NULL, $editIconDisplay = TRUE) {
	if ($editIconDisplay == TRUE) {
		print phptemplate_plugin_editIcon_marker('tx_air_table_marks', $idMarker, $title, NULL, 1);
	} else {
		print "";
	}
}
?>