<?php
/*
	tpl_render_CSS
*/
function phptemplate_plugin_tpl_render_CSS($self) {

	$cssFilesArray = array();
	$cssInlineArray = array();

		/**********************************************************************/
		/* _CSS_PAGE_STYLE
		/*
		/*
		/**********************************************************************/

		if (is_array($GLOBALS['TSFE']->tmpl->setup['plugin.'])) {
			$temp_styleLines = array ();
			foreach ($GLOBALS['TSFE']->tmpl->setup['plugin.'] as $key => $iCSScode) {
				if (is_array($iCSScode)) {
					if ($iCSScode['_CSS_DEFAULT_STYLE'] && empty($GLOBALS['TSFE']->config['config']['removeDefaultCss'])) {
						$temp_styleLines[] = '/* default styles for extension "' . substr($key, 0, - 1) . '" */' . LF . $iCSScode['_CSS_DEFAULT_STYLE'];
					}
					if ($iCSScode['_CSS_PAGE_STYLE']) {
						$temp_styleLines[] = '/* specific page styles for extension "' . substr($key, 0, - 1) . '" */' .
							LF . implode(LF, $iCSScode['_CSS_PAGE_STYLE']);
					}
				}
			}
			if (count($temp_styleLines)) {
				if ($GLOBALS['TSFE']->config['config']['inlineStyle2TempFile']) {
					$cssFilesArray = phptemplate_plugin_tpl_render_CSS_addCssFile($cssFilesArray,TSpagegen::inline2TempFile(implode(LF, $temp_styleLines), 'css'));
				} else {
					$cssInlineArray = phptemplate_plugin_tpl_render_CSS_addCssInlineBlock($cssInlineArray,'TSFEinlineStyle', implode(LF, $temp_styleLines));
				}
			}
		}

		if ($GLOBALS['TSFE']->pSetup['stylesheet']) {
			$ss = $GLOBALS['TSFE']->tmpl->getFileName($GLOBALS['TSFE']->pSetup['stylesheet']);
			if ($ss) {
				$cssFilesArray = phptemplate_plugin_tpl_render_CSS_addCssFile($cssFilesArray,$ss); // не понял для чего нужно
			}
		}
		
		/**********************************************************************/
		/* includeCSS
		/* config.includeCSS {
		/*
		/* }
		/**********************************************************************/

		if (is_array($GLOBALS['TSFE']->pSetup['includeCSS.'])) {
			foreach ($GLOBALS['TSFE']->pSetup['includeCSS.'] as $key => $CSSfile) {
				if (!is_array($CSSfile)) {
					$ss = $GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['external'] ? $CSSfile : $GLOBALS['TSFE']->tmpl->getFileName($CSSfile);
					if (isset($GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['if.'])
						&& !$GLOBALS['TSFE']->cObj->checkIf($GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['if.'])) {
						continue;
					}
					if ($ss) {
						if ($GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['import']) {
							if (! $GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['external'] && substr($ss, 0, 1) != '/') { // To fix MSIE 6 that cannot handle these as relative paths (according to Ben v Ende)
								$ss = t3lib_div::dirname(t3lib_div::getIndpEnv('SCRIPT_NAME')) . '/' . $ss;
							}
							$cssFilesArray = phptemplate_plugin_tpl_render_CSS_addCssFile(
								$cssFilesArray,
								'import_' . $key,
								'@import url("' . htmlspecialchars($ss) . '") ' . htmlspecialchars($GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['media']) . ';',
								empty($GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['disableCompression']),
								$GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['forceOnTop'] ? TRUE : FALSE,
								''
							);
						} else {
							$cssFilesArray = phptemplate_plugin_tpl_render_CSS_addCssFile(
								$cssFilesArray,
								$ss,
								$GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['alternate'] ? 'alternate stylesheet' : 'stylesheet',
								$GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['media'] ? $GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['media'] : 'all',
								$GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['title'] ? $GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['title'] : '',
								empty($GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['disableCompression']),
								$GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['forceOnTop'] ? TRUE : FALSE,
								$GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['allWrap'],
								$GLOBALS['TSFE']->pSetup['includeCSS.'][$key . '.']['excludeFromConcatenation'] ? TRUE : FALSE
							);
						}
					}
				}
			}
		}

			// Stylesheets
		$style = '';
		if ($GLOBALS['TSFE']->pSetup['insertClassesFromRTE']) {
			$pageTSConfig = $GLOBALS['TSFE']->getPagesTSconfig();
			$RTEclasses = $pageTSConfig['RTE.']['classes.'];
			if (is_array($RTEclasses)) {
				foreach ($RTEclasses as $RTEclassName => $RTEvalueArray) {
					if ($RTEvalueArray['value']) {
						$style .= '
.' . substr($RTEclassName, 0, - 1) . ' {' . $RTEvalueArray['value'] . '}';
					}
				}
			}

			if ($GLOBALS['TSFE']->pSetup['insertClassesFromRTE.']['add_mainStyleOverrideDefs'] && is_array($pageTSConfig['RTE.']['default.']['mainStyleOverride_add.'])) {
				$mSOa_tList = t3lib_div::trimExplode(',', strtoupper($GLOBALS['TSFE']->pSetup['insertClassesFromRTE.']['add_mainStyleOverrideDefs']), 1);
				foreach ($pageTSConfig['RTE.']['default.']['mainStyleOverride_add.'] as $mSOa_key => $mSOa_value) {
					if (! is_array($mSOa_value) && (in_array('*', $mSOa_tList) || in_array($mSOa_key, $mSOa_tList))) {
						$style .= '
' . $mSOa_key . ' {' . $mSOa_value . '}';
					}
				}
			}
		}
		
			// CSS_inlineStyle from TS
		$style .= trim($GLOBALS['TSFE']->pSetup['CSS_inlineStyle']);
		$style .= $GLOBALS['TSFE']->cObj->cObjGet($GLOBALS['TSFE']->pSetup['cssInline.'], 'cssInline.');

		if (trim($style)) {
			if ($GLOBALS['TSFE']->config['config']['inlineStyle2TempFile']) {
				$cssFilesArray = phptemplate_plugin_tpl_render_CSS_addCssFile($cssFilesArray,TSpagegen::inline2TempFile($style, 'css'));
			} else {
				$cssInlineArray = phptemplate_plugin_tpl_render_CSS_addCssInlineBlock($cssInlineArray,'additionalTSFEInlineStyle', $style);
			}
		}
		
	
		/**********************************************************************/
		/* Вывод
		/*
		/*
		/**********************************************************************/
		# print_r ($cssFilesArray);
		# print_r ($cssInlineArray);
		
		if (count($cssFilesArray)) {
			foreach ($cssFilesArray as $name => $properties) {
				$properties['file'] = t3lib_div::resolveBackPath($properties['file']);
				$properties['file'] = t3lib_div::createVersionNumberedFilename($properties['file']);
				$tag = '<link rel="' . htmlspecialchars($properties['rel']) . '" type="text/css" href="' .
					   htmlspecialchars($properties['file']) . '" media="' . htmlspecialchars($properties['media']) . '"' .
					   ($properties['title'] ? ' title="' . htmlspecialchars($properties['title']) . '"' : '') .
					   $endingSlash . '>';
				if ($properties['allWrap'] && strpos($properties['allWrap'], '|') !== FALSE) {
					$tag = str_replace('|', $tag, $properties['allWrap']);
				}
				if ($properties['forceOnTop']) {
					$cssFiles = $tag . LF . $cssFiles;
				} else {
					$cssFiles .= LF . TAB . $tag;
				}
			}
		}

		if (count($cssInlineArray)) {
			foreach ($cssInlineArray as $name => $properties) {
				if ($properties['forceOnTop']) {
					$cssInline = '/*' . htmlspecialchars($name) . '*/' . LF . $properties['code'] . LF . $cssInline;
				} else {
					$cssInline .= '/*' . htmlspecialchars($name) . '*/' . LF . $properties['code'] . LF;
				}
			}
			$inlineCssWrap = array(
				'<style type="text/css">' . LF . '/*<![CDATA[*/' . LF . '<!-- ' . LF,
				'-->' . LF . '/*]]>*/' . LF . '</style>' . LF
			);
			$cssInline = LF.LF.$inlineCssWrap[0] . LF . $cssInline . LF . $inlineCssWrap[1];
		}

	$CssTags = LF.TAB."<!--CSS (section for head 3)-->";
	$CssTags .= $cssFiles;
	$CssTags .= $cssInline;
	$CssTags .= LF;
	return $CssTags;

}

	/**
	 * Adds CSS file
	 *
	 * @param string $file
	 * @param string $rel
	 * @param string $media
	 * @param string $title
	 * @param boolean $compress
	 * @param boolean $forceOnTop
	 * @param string $allWrap
	 * @param boolean $excludeFromConcatenation
	 * @return void
	 */
	function phptemplate_plugin_tpl_render_CSS_addCssFile($cssFilesArray, $file, $rel = 'stylesheet', $media = 'all', $title = '', $compress = TRUE, $forceOnTop = FALSE, $allWrap = '', $excludeFromConcatenation = FALSE) {
		if (!isset($cssFilesArray[$file])) {
			$cssFilesArray[$file] = array(
				'file' => $file,
				'rel' => $rel,
				'media' => $media,
				'title' => $title,
				'compress' => $compress,
				'forceOnTop' => $forceOnTop,
				'allWrap' => $allWrap,
				'excludeFromConcatenation' => $excludeFromConcatenation,
			);
		}
		return $cssFilesArray;
	}

	/*CSS Inline Blocks */

	/**
	 * Adds CSS inline code
	 *
	 * @param string $name
	 * @param string $block
	 * @param boolean $compress
	 * @param boolean $forceOnTop
	 * @return void
	 */
	function phptemplate_plugin_tpl_render_CSS_addCssInlineBlock($cssInlineArray, $name, $block, $compress = FALSE, $forceOnTop = FALSE) {
		if (!isset($cssInlineArray[$name]) && !empty($block)) {
			$cssInlineArray[$name] = array(
				'code' => $block,
				'compress' => $compress,
				'forceOnTop' => $forceOnTop
			);
		}
		return $cssInlineArray;
	}
